﻿// Find in Tables
// Скрипт выполняет поиск заданного Grep-выражения в таблице
// ячейкам с найденным текстом присваивается заданный стиль CellStyle
// adobeindesign.ru, boriskasmoscow@gmail.com
// Перед запуском скрипта поставьте текстовый курсор в любую ячейку таблицы


var myFind, myCellStyle;
var styleForRow; // стиль для всей строки false или true
var mergeCellsInRow;
main();

function main()
{
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;
    if (app.documents.length != 0){
        var nTables= app.documents.item(0).stories.everyItem().tables.length; // узнаем, сколько таблиц в документе
        if( nTables == 0) // в документе нет таблиц, работа не имеет смысла
        {
            alert("В документе нет таблиц. Работа невозможна"); exit();
        }
        var myTable = get_table ();
        if(myTable== null) exit();
        var myCellStyleList = myGetCellStyleNames();
        var myWin = myDialog(myCellStyleList);
        if (myWin.show() == 1) { 
           //alert(myFind);
           //alert(myCellStyle);
           findInTable(myTable);
        }
    } // if app
    else {
      alert("Нет открытых документов!");
      exit();
    }


   
} // main

function myDialog(myCellStList)
{
    var myDg = new Window('dialog', "Find for Tables");
    
	myDg.orientation = "column";
    myDg.alignChildren = "center";
    var myPnl = myDg.add("panel", undefined, 'Ввод данных');
	myPnl.orientation = "column";
    myPnl.alignChildren = "left";
    //myPnl.size = [400, 120];  
    
    var myGroup0 = myPnl.add("group");
    myGroup0.orientation = "row";
    var myText0 = myGroup0.add ("statictext", undefined);
    myText0.text = "Найти"; 
     var myEditTxt0 = myGroup0.add("edittext", undefined, "");
    myEditTxt0.characters = 16;
    
     var myGroup1 = myPnl.add("group");
    myGroup1.orientation = "row";   
    myDropdown= myGroup1.add ("dropdownlist", undefined, myCellStList);
    myDropdown.title = "Присвоить стиль ячеек:";
    myDropdown.selection=0;
    myDropdown.minimumSize = [100, 20];    
    myCheckbox0 = myGroup1.add('checkbox', undefined, "всей строке");
    myCheckbox0.value = false;
    myCheckbox1 = myPnl.add('checkbox', undefined, "Объединить ячейки строки");
    myCheckbox1.value = false;
 
    
    // add buttons    
    var myButtonGroup = myDg.add( "group" );
    var OKButton = myButtonGroup.add( "button", undefined, "OK" );
    OKButton.enabled = true;
    OKButton.helpTip = "This is start button";
    OKButton.onClick = function()
    {
        myFind = myEditTxt0.text;
        myCellStyle=myDropdown.selection.text;
        styleForRow = myCheckbox0.value;
        mergeCellsInRow = myCheckbox1.value;
        myDg = this.window.close( 1 );
    }
    
    var myCancelButton = myButtonGroup.add( "button", undefined, "Cancel" );
    myCancelButton.onClick = function() { myDg = this.window.close( 0 ); }
    
    return myDg;
}

function findInTable(myObj)
{
var myCell, myRow;
//alert(myObj.constructor.name);
myCellStyle = getCellStyleByName(myCellStyle);
app.findGrepPreferences = app.changeGrepPreferences = NothingEnum.nothing;
app.findChangeGrepOptions.includeFootnotes = false;
app.findChangeGrepOptions.includeHiddenLayers = false;
app.findChangeGrepOptions.includeLockedLayersForFind = false;
app.findChangeGrepOptions.includeLockedStoriesForFind = false;
app.findChangeGrepOptions.includeMasterPages = false;
// строка для поиска 
app.findGrepPreferences.findWhat = myFind;
// поиск!
var foundText = myObj.findGrep();
    if(foundText.length == 0) {
        alert("Здесь ничего не найдено.");
        exit();
    }
for(var i=0; i< foundText.length; i++) {

        myCell = foundText[i].parent;
        myCell.appliedCellStyle = myCellStyle; 
        myCell.clearCellStyleOverrides( true );
        if(styleForRow)
        {
            myRow = myCell.parentRow;
            myRow.cells.everyItem().appliedCellStyle = myCellStyle; 
            myRow.cells.everyItem().clearCellStyleOverrides();
        }
        if(mergeCellsInRow)
        {
            myRow.cells.item(0).merge( myRow.cells.itemByRange(1, -1) ); 
        }
 } // for    
    
} // fnc

function myGetCellStyleNames()
{
    var result = [];    
    var myCellStyles = app.activeDocument.allCellStyles;
    var myCellStyleName, obj;
    for(var i=0; i < myCellStyles.length ; i++)
    {
        myCellStyleName = myCellStyles[i].name;
        obj = myCellStyles[i];
        while(obj.parent instanceof CellStyleGroup)
        {
            myCellStyleName = obj.parent.name + ":" + myCellStyleName;
            obj = obj.parent;        
        }
        result.push(myCellStyleName);
     } // for
    //result.unshift("[Не изменять]"); // 
    return result;
} //fnc


function get_table () {
	try {
		if (app.selection[0].parent instanceof Cell)  // Insertion point in a cell
			return app.selection[0].parent.parent;
		if (app.selection[0].parent instanceof Table)  // Cell selected
			return app.selection[0].parent;
		if (app.selection[0] instanceof Table)   // All cells selected
			return app.selection[0];
		if (app.selection[0].tables.length == 1)   // The selection (text frame, paragraph, word) contains one table
			return app.selection[0].tables[0];
		if (app.selection[0].tables.length > 1)
        {
			alert ('В выделенном содержится несколько таблиц, мы можем работать только с одной.');
              return null;
        }
	} catch(_) {
		alert ('Поставьте курсор в любую ячейку таблицы');
        return null;
	}
}


function getCellStyleByName(myStyleName)
{
var myCellStyles = app.activeDocument.allCellStyles;
var myCellStyleName, obj;
    for(var i=0; i < myCellStyles.length ; i++)
    {
        myCellStyleName = myCellStyles[i].name;
        obj = myCellStyles[i];
        while(obj.parent instanceof CellStyleGroup)
        {
            myCellStyleName = obj.parent.name + ":" + myCellStyleName;
            obj = obj.parent;        
        }
        if(myCellStyleName == myStyleName)  return myCellStyles[i];
     } // for
    
} // fnc

/*
function findTable(obj) {
	if (obj.constructor.name == "Table") { return obj }
	while (obj.constructor.name != "Table") {
		obj = obj.parent;
		if (obj.constructor.name == "Application")  {
			return null;
		}
	}
	return obj;
} // fnc
*/